unit Form_Client;
{APPTYPE CONSOLE}
{Historic:
Version 0.1 (17/03/2018):
 * port TCP/IP by default: 50001 instead 3020
Version 0 (25/01/2017):
 * original issue}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Buttons, ComCtrls,ShellApi;

type
  TForm1 = class(TForm)
    GroupBox3: TGroupBox;
    Memo_Reception_Text: TMemo;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    Memo_Log: TMemo;
    Connection: TSpeedButton;
    Disconnection: TSpeedButton;
    Edit1: TEdit;
    Manual_command: TButton;
    Label5: TLabel;
    GroupBox7: TGroupBox;
    Memo_reception_commands: TMemo;
    ClientSocket1: TClientSocket;
    procedure ConnectionClick(Sender: TObject);
    procedure DisconnectionClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormActivate(Sender: TObject);
    procedure Manual_commandClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

VAR Datetime:TDateTime;
var Date_Str: string;

{$R *.dfm}
{************}

procedure TForm1.ConnectionClick(Sender: TObject);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Connexion asked');
 ClientSocket1.Open;
end;

{***********}

procedure TForm1.DisconnectionClick(Sender: TObject);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Disconnexion asked');
 {Close the socket connexion}
 ClientSocket1.Close;
end;

{**********}

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is connected to the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Connected to '+Socket.RemoteHost);
 Form1.Connection.down:=TRUE;
end;

{**********}

procedure TForm1.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the server is being searched by the client}
 Memo_Log.Lines.Add(Date_Str+': '+'The server is being searched');
end;

{**********}

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is going to disconnect from the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Disconnected');
 Form1.Disconnection.down:=TRUE;
end;

{**********}

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
{management of a received string of characters}
VAR RECEIVED:STRING;
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 RECEIVED:=Socket.ReceiveText;
 Memo_Reception_Text.Text:=Memo_Reception_Text.Text+Date_str+': '+RECEIVED+CHR(13)+CHR(10);
end;

{**********}

procedure TForm1.ClientSocket1Error(Sender: TObject;Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
var ErrorMsg: string;
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 STR(ErrorCode,ErrorMsg);
 Memo_Log.Lines.Add(Date_Str+'  Error: '+ErrorMsg);
 {The error is managed}
 ErrorCode := 0;
 Form1.Disconnection.down:=TRUE;
end;

{*********}

procedure TForm1.FormActivate(Sender: TObject);
begin
 Memo_reception_Text.setfocus;
end;

{***********}

PROCEDURE TRANSMISSION_TCP_IP_COMMAND(COMMAND:STRING);
{to the Multipsk server}
BEGIN
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Form1.ClientSocket1.Socket.SendText(COMMAND);
 {display the command}
 Form1.Memo_reception_Commands.Lines.Add(Date_str+' Command: '+COMMAND);
END;

{***********}

procedure TForm1.Manual_commandClick(Sender: TObject);
VAR COMMAND:STRING;
begin
 COMMAND:=Edit1.Text;
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

end.
