unit POUBELLE;

 IF (HARDWARE_TYPE<>4) AND (RECEPTION_DATA_IN_PROGRESS=FALSE) AND (DATA_MUST_BE_SENT=TRUE) AND (SIMULATED_DATA_TO_SEND=TRUE) THEN {Simulation of data transmitted}

interface

implementation
{Paquets are sent by 8092 characters (2048 IQ samples). So the timer1 frequency must superior to
48000/2048=23 (to receive a sole paquet, even if not critical).
Set it to the fastest possible (interval=1) is the good solution (in reality the maximum is around 80/sec)}
VAR BUG_INFORMATION:STRING;
VAR LENGTH_INFORMATION:WORD;
VAR DELTA_TIME,NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT:DWORD;
VAR NUMBER_OF_IQ_SAMPLES_TO_SEND:DWORD;
VAR NUMBER_OF_PERIODS_OF_SIGNAL_TO_SEND,COUNTER:DWORD;
VAR STRING_TO_SEND,STRING0:STRING;
VAR COMPTEUR:DWORD;
VAR Min,Max:SMALLINT;
VAR Final_min,Final_max:WORD;{signed number to 2's complement number}

 {!!!!!!!!}

 PROCEDURE TRANSMISSION_OF_I_Q(I,Q:WORD);
 VAR STRING1:STRING;
 BEGIN
  STRING1:=CHR(I MOD 256)+CHR(I DIV 256)+CHR(Q MOD 256)+CHR(Q DIV 256);
  STRING_TO_SEND:=STRING_TO_SEND+STRING1;
 END;

begin
 {The MP server, must consider that after 15 seconds waiting for a CP event the CP has some problem and the MP will disconnect the CP.}
 IF (CONTROL_OF_MAXIMUM_DELAY_ACTIVATED=TRUE) AND ((GetTickCount-Initial_time_of_an_event_for_waiting_delay)>Maximum_delay_to_receive_the_expected_event) THEN
 BEGIN
  CONTROL_OF_MAXIMUM_DELAY_ACTIVATED:=FALSE;{to avoid re-coming}
  DateTime := Time; Date_str := TimeToStr(DateTime);
  Memo_Log.Lines.Add(Date_Str+': '+'Client absent from more than 15 seconds, so automatic disconnection');
  {The client is warned, by a bug information before being disconnected}
  BUG_INFORMATION:='Disconnection due to a too long waiting time';
  LENGTH_INFORMATION:=LENGTH(BUG_INFORMATION);
  Non_blocking_Delay(10);{a small delay is indispensable}
  TRANSMISSION_TCP_IP_COMMAND('Bug_on_P'+CHR(LENGTH_INFORMATION)+BUG_INFORMATION,TRUE);
  Non_blocking_Delay(100);{Leave the message be transmitted}
  Disconnection_TCP_IP;{of the client}
  INITIALIZATION_AND_CONNECTION;
 END;

 {For the hardware Type 4, it is regularly (each second) sent an empty TXHWdata to be sure that the link is effective}
 IF (HARDWARE_TYPE=4) AND (DATA_MUST_BE_SENT=TRUE) AND (GetTickCount-Initial_time_of_TXHWdata_transmission>=1000) THEN
 BEGIN
  {empty TXHWdata}
  TRANSMISSION_TCP_IP_COMMAND('TXHWdata'+CHR(0)+CHR(0)+CHR(0)+CHR(0),FALSE);
  Initial_time_of_TXHWdata_transmission:=GetTickCount;{reinitialization}
  {To show activity}
  IF NOMBRE_MILLIERS.Caption='.' THEN NOMBRE_MILLIERS.Caption:='..' ELSE
  IF NOMBRE_MILLIERS.Caption='..' THEN NOMBRE_MILLIERS.Caption:='...' ELSE
  IF NOMBRE_MILLIERS.Caption='...' THEN NOMBRE_MILLIERS.Caption:='....' ELSE
  IF NOMBRE_MILLIERS.Caption='....' THEN NOMBRE_MILLIERS.Caption:='.....' ELSE NOMBRE_MILLIERS.Caption:='.';
 END;

 {Data transmission in Hardware type 3}
 {It is important to not re-enter in the procudure before the end, so use of Timer1.Enabled}
 IF (HARDWARE_TYPE=3) AND (DATA_MUST_BE_SENT=TRUE) AND (SIMULATED_DATA_TO_SEND=TRUE) THEN {Simulation of data transmitted}
 {It is simulated a square signal at a frequency of 6000 Hz with a SR (sampling frequency) of 48000 Hz and 16 bits for I and Q.
 So the period of the signal will equal to 8 samples SR=48000/6000.
 With a period of 8 samples the Q is out of phase of 2 samples (Pi/2) from I.
 However this permits to have two traces on Multipsk, on each side of the SdR waterfall}
 BEGIN
  {It is important to not re-enter in the procudure before the end, so use of Timer1.Enabled}
  Timer1.Enabled:=FALSE;
  {First call to this function, initialization}
  IF INITIAL_TIME_OF_DATA_TRANSMISSION=0 THEN
  BEGIN
   INITIAL_TIME_OF_DATA_TRANSMISSION:=GetTickCount;
   NUMBER_OF_IQ_SAMPLES_SENT:=0;
  END ELSE
  {Next calls}
  BEGIN
   DELTA_TIME:=GetTickCount-INITIAL_TIME_OF_DATA_TRANSMISSION;
   NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT:=48*DELTA_TIME;{normally: (48000*DELTA_TIME) DIV 1000};
   NUMBER_OF_IQ_SAMPLES_TO_SEND:=NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT-NUMBER_OF_IQ_SAMPLES_SENT;
   IF NUMBER_OF_IQ_SAMPLES_TO_SEND=0 THEN EXIT;
   {Transmission with Q delayed from I of Pi/2}
   {NUMBER_OF_IQ_SAMPLES_TO_SEND DIV 8 is the number of periods (with 8 samples/period at 6000 Hz}
   STRING_TO_SEND:='';

   {The initial signed signal is symmetrical between -32767  32767. It is produced here a square signal
   so between min and max}
   Min:=-32767; Max:=32767;
   Final_min:=Min;    Final_max:=Max; {signed number to 2's complement number: SMALLINIT to WORD}
   FOR COUNTER:=1 TO (NUMBER_OF_IQ_SAMPLES_TO_SEND DIV 8) DO
   BEGIN
    {for test: TRANSMISSION_OF_I_Q(12336,12336); TRANSMISSION_OF_I_Q(12593,12593); TRANSMISSION_OF_I_Q(12850,12850); TRANSMISSION_OF_I_Q(13107,13107);
    TRANSMISSION_OF_I_Q(13364,13364); TRANSMISSION_OF_I_Q(13621,13621); TRANSMISSION_OF_I_Q(13878,13878); TRANSMISSION_OF_I_Q(14135,14135);}
    {Sqaure wave signal}
    TRANSMISSION_OF_I_Q(Final_min,Final_max);
    TRANSMISSION_OF_I_Q(Final_min,Final_max);
    TRANSMISSION_OF_I_Q(Final_min,Final_min);
    TRANSMISSION_OF_I_Q(Final_min,Final_min);
    TRANSMISSION_OF_I_Q(Final_max,Final_min);
    TRANSMISSION_OF_I_Q(Final_max,Final_min);
    TRANSMISSION_OF_I_Q(Final_max,Final_max);
    TRANSMISSION_OF_I_Q(Final_max,Final_max);
   END;
   {16 bits for I and Q, so 32 bits for I+Q or 4 characters}
   STRING0:=TRANSFORMATION_LONGWORD_IN_CHARACTERS_LITTLE_ENDIAN(NUMBER_OF_IQ_SAMPLES_TO_SEND*4);
   {Display useless after having being correctly connected and controlled (as it takes CPU)}
   IF (CLIENT_CONNECTED=TRUE) AND (SERVER_IN_SERVICE=TRUE) THEN{in case of disconnection while in the timer}
   BEGIN
    TRANSMISSION_TCP_IP_COMMAND('TXHWdata'+STRING0+STRING_TO_SEND,FALSE);
    INC(NUMBER_OF_IQ_SAMPLES_SENT,NUMBER_OF_IQ_SAMPLES_TO_SEND);

    {for test: STR(NUMBER_OF_IQ_SAMPLES_TO_SEND,STRING0); Button1.Caption;}

    {Display of the Kdata transmitted}
    INC(NUMBER_OF_CHARACTERS_TRANSMITTED,NUMBER_OF_IQ_SAMPLES_TO_SEND*4);
    COMPTEUR:=NUMBER_OF_CHARACTERS_TRANSMITTED DIV 1000;
    IF COMPTEUR>PREVIOUS_NUMBER_OF_CHARACTERS_TRANSMITTED THEN
    BEGIN
     STR(COMPTEUR,STRING0);
     NOMBRE_MILLIERS.Caption:='N(Kdata)='+STRING0;
     PREVIOUS_NUMBER_OF_CHARACTERS_TRANSMITTED:=COMPTEUR;//rinitialisation
    END;

    {To avoid to pass the DWORD length}
    IF NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT>480000000 THEN
    BEGIN
     INC(INITIAL_TIME_OF_DATA_TRANSMISSION,10000000);
     DEC(NUMBER_OF_IQ_SAMPLES_SENT,480000000);
    END;
   END;
  END;
  Timer1.Enabled:=TRUE;{Timer ready now that it is finished}
 END;

end.






 {Data transmission in Hardware type 3}
 {It is important to not re-enter in the procudure before the end, so use of Timer1.Enabled}
 IF (HARDWARE_TYPE=3) AND (DATA_MUST_BE_SENT=TRUE) AND (SIMULATED_DATA_TO_SEND=TRUE) THEN {Simulation of data transmitted}
 {It is simulated a square signal at a frequency of 6000 Hz with a SR (sampling frequency) of 48000 Hz and 16 bits for I and Q.
 So the period of the signal will equal to 8 samples SR=48000/6000.
 With a period of 8 samples the Q is out of phase of 2 samples (Pi/2) from I.
 However this permits to have two traces on Multipsk, on each side of the SdR waterfall}
 BEGIN
  {It is important to not re-enter in the procudure before the end, so use of Timer1.Enabled}
  Timer1.Enabled:=FALSE;
  {First call to this function, initialization}
  IF INITIAL_TIME_OF_DATA_TRANSMISSION=0 THEN
  BEGIN
   INITIAL_TIME_OF_DATA_TRANSMISSION:=GetTickCount;
   NUMBER_OF_IQ_SAMPLES_SENT:=0;
  END ELSE
  {Next calls}
  BEGIN

   DELTA_TIME:=GetTickCount-INITIAL_TIME_OF_DATA_TRANSMISSION;
   NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT:=48*DELTA_TIME;{normally: (48000*DELTA_TIME) DIV 1000};
   NUMBER_OF_IQ_SAMPLES_TO_SEND:=NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT-NUMBER_OF_IQ_SAMPLES_SENT;
   {WRITELN('Delta_time ',NUMBER_OF_IQ_SAMPLES_TO_SEND,' ',DELTA_TIME,' ',INITIAL_TIME_OF_DATA_TRANSMISSION);}
   IF NUMBER_OF_IQ_SAMPLES_TO_SEND=0 THEN EXIT;
   {Transmission with Q delayed from I of Pi/2}
   {NUMBER_OF_IQ_SAMPLES_TO_SEND DIV 8 is the number of periods (with 8 samples/period at 6000 Hz}
   STRING_TO_SEND:='';

   {The initial signed signal is symmetrical between -32767  32767. It is produced here a square signal
   so between min and max}
   Min:=-32767; Max:=32767;
   Final_min:=Min;    Final_max:=Max; {signed number to 2's complement number: SMALLINIT to WORD}
   FOR COUNTER:=1 TO (NUMBER_OF_IQ_SAMPLES_TO_SEND DIV 8) DO
   BEGIN
    {for test: TRANSMISSION_OF_I_Q(12336,12336); TRANSMISSION_OF_I_Q(12593,12593); TRANSMISSION_OF_I_Q(12850,12850); TRANSMISSION_OF_I_Q(13107,13107);
    TRANSMISSION_OF_I_Q(13364,13364); TRANSMISSION_OF_I_Q(13621,13621); TRANSMISSION_OF_I_Q(13878,13878); TRANSMISSION_OF_I_Q(14135,14135);}
    {Sqaure wave signal}
    TRANSMISSION_OF_I_Q(Final_min,Final_max);
    TRANSMISSION_OF_I_Q(Final_min,Final_max);
    TRANSMISSION_OF_I_Q(Final_min,Final_min);
    TRANSMISSION_OF_I_Q(Final_min,Final_min);
    TRANSMISSION_OF_I_Q(Final_max,Final_min);
    TRANSMISSION_OF_I_Q(Final_max,Final_min);
    TRANSMISSION_OF_I_Q(Final_max,Final_max);
    TRANSMISSION_OF_I_Q(Final_max,Final_max);
   END;
   WRITELN('N ',NUMBER_OF_IQ_SAMPLES_TO_SEND*4);

   REPEAT
    STRING1:=COPY(STRING_TO_SEND,1,4000);
    DELETE(STRING_TO_SEND,1,4000);
    {16 bits for I and Q, so 32 bits for I+Q or 4 characters}
    STRING0:=TRANSFORMATION_LONGWORD_IN_CHARACTERS_LITTLE_ENDIAN(LENGTH(STRING1));
    {WRITELN('nn ',LENGTH(STRING1),' ',LENGTH(STRING_TO_SEND));}

    {Display useless after having being correctly connected and controlled (as it takes CPU)}
    IF (CLIENT_CONNECTED=TRUE) AND (SERVER_IN_SERVICE=TRUE) THEN{in case of disconnection while in the timer}
    BEGIN
     TRANSMISSION_TCP_IP_COMMAND('TXHWdata'+STRING0+STRING1,FALSE);
    END ELSE BREAK;
   UNTIL STRING_TO_SEND='';

   INC(NUMBER_OF_IQ_SAMPLES_SENT,LENGTH(STRING_TO_SEND));

   {for test: STR(NUMBER_OF_IQ_SAMPLES_TO_SEND,STRING0); Button1.Caption;}

   {Display of the Kdata transmitted}
   INC(NUMBER_OF_CHARACTERS_TRANSMITTED,LENGTH(STRING_TO_SEND));
   COMPTEUR:=NUMBER_OF_CHARACTERS_TRANSMITTED DIV 1000;
   IF COMPTEUR>PREVIOUS_NUMBER_OF_CHARACTERS_TRANSMITTED THEN
   BEGIN
    STR(COMPTEUR,STRING0);
    NOMBRE_MILLIERS.Caption:='N(Kdata)='+STRING0;
    PREVIOUS_NUMBER_OF_CHARACTERS_TRANSMITTED:=COMPTEUR;//rinitialisation
   END;

   {To avoid to pass the DWORD length}
   IF NUMBER_OF_IQ_SAMPLES_WHICH_MUST_HAVE_NORMALLY_BEEN_SENT>480000000 THEN
   BEGIN
    INC(INITIAL_TIME_OF_DATA_TRANSMISSION,10000000);
    DEC(NUMBER_OF_IQ_SAMPLES_SENT,480000000);
   END;
  END;
  Timer1.Enabled:=TRUE;{Timer ready now that it is finished}
 END;
