unit Form_Server;
{APPTYPE CONSOLE}
{Historic:
Version 0.1 (17/03/2018):
 * port TCP/IP by default: 50001 instead 3020
Version 0 (25/01/2017):
 * original issue}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Buttons, ComCtrls,ShellApi;

type
  TForm1 = class(TForm)
    GroupBox3: TGroupBox;
    Memo_Reception_Text: TMemo;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    Memo_Log: TMemo;
    Connection: TSpeedButton;
    Disconnection: TSpeedButton;
    Edit1: TEdit;
    Manual_command: TButton;
    Label5: TLabel;
    GroupBox7: TGroupBox;
    Memo_reception_commands: TMemo;
    ServerSocket1: TServerSocket;
    procedure ConnectionClick(Sender: TObject);
    procedure DisconnectionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Manual_commandClick(Sender: TObject);
    procedure ServerSocket1Accept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1Listen(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

VAR Datetime:TDateTime;
var Date_Str: string;

{$R *.dfm}
{************}

procedure TForm1.ConnectionClick(Sender: TObject);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Link opening');
 ServerSocket1.Port:=50001; //Define the port used
 ServerSocket1.Open; //Open the socket connection
end;

{***********}

procedure TForm1.DisconnectionClick(Sender: TObject);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Disconnexion asked');
 {Close the socket connexion}
 ServerSocket1.Close; 
end;

{**********}

procedure TForm1.ServerSocket1Accept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message indicates the distant IP address of the client connecting to the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Connected to '+Socket.RemoteAddress);
 Form1.Connection.down:=TRUE;
end;

{**********}

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is connected to the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Connection accepted by the server socket');
end;

{**********}

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is disconnected from the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Client disconnected from the server');
// Form1.Disconnection.down:=TRUE;//However, another client can connect
end;

{**********}

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
var ErrorMsg: string;
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 STR(ErrorCode,ErrorMsg);
 Memo_Log.Lines.Add(Date_Str+'  Error: '+ErrorMsg);
 {The error is managed}
 ErrorCode := 0;
 Form1.Disconnection.down:=TRUE;
end;

{**********}

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
VAR RECEIVED:STRING;
begin
 {management of a received string of characters}
 DateTime := Time; Date_str := TimeToStr(DateTime);
 RECEIVED:=Socket.ReceiveText;
 Memo_Reception_Text.Text:=Memo_Reception_Text.Text+Date_str+': '+RECEIVED+CHR(13)+CHR(10);
end;

{**********}

procedure TForm1.ServerSocket1Listen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Listening...');
end;

{*********}

procedure TForm1.FormActivate(Sender: TObject);
begin
 Memo_reception_Text.setfocus;
end;

{***********}

PROCEDURE TRANSMISSION_TCP_IP_COMMAND(COMMAND:STRING);
{to the Multipsk server}
BEGIN
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Form1.ServerSocket1.Socket.Connections[0].SendText(COMMAND);
 {display the command}
 Form1.Memo_reception_Commands.Lines.Add(Date_str+' Command: '+COMMAND);
END;

{***********}

procedure TForm1.Manual_commandClick(Sender: TObject);
VAR COMMAND:STRING;
begin
 COMMAND:=Edit1.Text;
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

end.
